
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#ifdef LINUX
#include <unistd.h>
#include <sys/shm.h>
#include <signal.h>

static int shmkey;
static struct shmid_ds buf;
static char *cmdaddr;

#else
#include "conio.h"
#endif

#include "ahp.h"


void ReadKeyboard(void);

int kpid=-1;
int xportnum=-1;
int quit=0;

char logbuf[256];

int main(int argc, char *argv)
{
    StartUser();

    xportnum=InitX10();

    if(xportnum>=0)
    {
        Logit("Have Access to CM15A for X10","");
    }
    else
    {
        Logit("NO Access to CM15A for X10","");
    }

    LoadX10Dev();

    printf("\nAvailable Keyboard Commands:\n");
    printf("  l - List Devices and Status\n");
    printf("  q - quit\n");
    if(xportnum>=0)
        printf("  x - CM15A X10 interface Commands\n");
    printf("\n");

    while(!quit)
    {
        msDelay(5000);
        UserInput();
    }
    KillUser();
    CloseX10();
    return 0;
    exit(0);
}

//--------------------------------------------------------------------------
//  Description:
//     Delay for at least 'len' ms
//
void msDelay(int len)
{
#ifdef LINUX
   struct timespec s;              // Set aside memory space on the stack

   s.tv_sec = len / 1000;
   s.tv_nsec = (len - (s.tv_sec * 1000)) * 1000000;
   nanosleep(&s, NULL);
#endif
}

char *TS(void)
{
    static char ts[100];
    time_t now;
    struct tm *lnow;


    time(&now);
    lnow=localtime(&now);

    sprintf(ts,"%02d/%02d %02d:%02d:%02d",
        lnow->tm_mon+1,lnow->tm_mday,
        lnow->tm_hour, lnow->tm_min,lnow->tm_sec);

    return ts;
}


void Logit(char *str1,char *str2)
{
    printf("%s %-25s%s\n",TS(),str1,str2);
    fflush(stdout);
}


char *StripTail(char *s)
{
    int i;
    i=strlen(s)-1;

    while(i>=0 && s[i]<=' ')
    {
        s[i]='\0';
        i--;
    }
    return s;
}


void DoCommand(char *buf)
{
    int i;
    char ch;

    ch=buf[0];
    i=1;
    while(buf[i]==' ' || buf[i]=='=') i++;

    if(ch=='l' || ch=='L')
    {
        if(xportnum>=0) SPrintX10Devices();
    }
    else if(xportnum>=0 && (ch=='x' || ch=='X')) X10deviceAction(&buf[i]);
    else if(ch=='q' || ch=='Q') quit=1;
    else printf("Unknown or unavailable command\n");
}



void StartUser(void)
{
#ifdef LINUX
    shmkey=shmget(91858,200,IPC_CREAT);
    if(shmkey==-1)
    {
        sprintf(logbuf,"Could not attach to User Input shared memory!");
        Logit(logbuf,"");
        exit(1);
    }
    cmdaddr=(char *)shmat(shmkey,NULL,0);
    shmctl(shmkey,IPC_RMID,&buf);
    cmdaddr[0]=0;
    kpid=fork();
    if(kpid==0)
    {
        ReadKeyboard();
        exit(0);
    }
#else
    return;
#endif
}

void KillUser(void)
{
#ifdef LINUX
    if(kpid>0) kill(kpid,SIGTERM);
    shmdt(cmdaddr);
#else
    return;
#endif
}

//child process to get KB input
void ReadKeyboard(void)
{
#ifdef LINUX
    char buffer[101];
    cmdaddr=(char *)shmat(shmkey,NULL,0);
    while(1)
    {
        if(cmdaddr[0]=='\0')
        {
            fgets(buffer,100,stdin);
            StripTail(buffer);
            if(buffer[0]>' ') strcpy(cmdaddr,buffer);;
        }
        else msDelay(1000);
    }
#endif
}


void UserInput(void)
{
#ifdef LINUX
    if(cmdaddr[0]!='\0')
    {
        DoCommand(cmdaddr);
        cmdaddr[0]='\0';
    }
#else
    char ch[101];

    if(kbhit())
    {
        ch[0]=getch();
        putch(ch[0]);
        while(getch()!='\r');
        putch('\n');
        ch[1]='\0';
        DoCommand(ch);
    }
#endif
}


#ifdef LINUX

void strupr(char *s)
{
	int i;

	i=0;
	while(s[i]!='\0')
	{
		if(s[i]>='a' && s[i]<='z') s[i]=s[i]-('a'-'A');
		i++;
	}
}

int stricmp(char *s1,char *s2)
{
	char m1[1024],m2[1024];

	strcpy(m1,s1);
	strupr(m1);
	strcpy(m2,s2);
	strupr(m2);

	return strcmp(m1,m2);
}
#endif

